# k8s
#
# deploys k8s

MANDATORY = $(shell printenv MANDATORY) K8S_CONTEXT
K8S_MANIFEST_FILENAME ?= kubernetes.yaml
ifneq ("$(wildcard secrets.yaml)","")
  SECRETS="secrets.yaml"
else
  SECRETS=""
endif

start-k8s:
	@- echo "\n### starting deployment with k8s"
	@- echo "\n### setting kubernetes context to $(K8S_CONTEXT)"
	@ kubectl config use-context $(K8S_CONTEXT)

	@- echo "\n### run kubectl apply -f $(K8S_MANIFEST_FILENAME) and if available secrets file $(SECRETS)"
	@ cat $(K8S_MANIFEST_FILENAME) $(SECRETS) | envsubst | kubectl apply $(K8S_ADDITIONAL_PARAMS) -f -

pull-k8s:
# nop

